# Class OjGantt

The component WebElement for oj-gantt. Do not instantiate this class directly, instead, use ojGantt.

#### Hierarchy

- OjGanttBase
  - OjGantt

#####
Index

### Constructors

constructor

### Methods

changeScrollPosition
changeSelection
clear
click
findElement
findElements
getAnimationOnDataChange
getAnimationOnDisplay
getAs
getAttribute
getAxisPosition
getCssValue
getDependencies
getDependencyLineShape
getDnd
getDragMode
getDriver
getEnd
getGridlines
getId
getLocation
getMajorAxis
getMinorAxis
getProperty
getRect
getReferenceObjects
getRowAxis
getRowDefaults
getRows
getScrollPosition
getSelection
getSelectionBehavior
getSelectionMode
getShadowRoot
getSize
getStart
getTagName
getTaskAggregation
getTaskDefaults
getText
getTimeCursor
getTooltip
getTrackResize
getTranslations
getValueFormats
getViewportEnd
getViewportStart
getZooming
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new OjGantt(el, locators): OjGantt

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjGantt

  Inherited from OjGanttBase.constructor

## Methods

### changeScrollPosition

- changeScrollPosition(scrollPosition): Promise<void>

- Sets the value of `scrollPosition` property. The current scroll position of the Gantt. See the Help documentation for more information.

  #### Parameters

  - ##### scrollPosition: ScrollPosition

    The value to set for `scrollPosition`

  #### Returns Promise<void>

  Inherited from OjGanttBase.changeScrollPosition

### changeSelection

- changeSelection(selection): Promise<void>

- Sets the value of `selection` property. An array containing the ids of the initially selected tasks.

  #### Parameters

  - ##### selection: any[]

    The value to set for `selection`

  #### Returns Promise<void>

  Inherited from OjGanttBase.changeSelection

### clear

- clear(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjGanttBase.clear

### click

- click(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjGanttBase.click

### findElement

- findElement(locator): WebElementPromise

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  Inherited from OjGanttBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  Inherited from OjGanttBase.findElements

### getAnimationOnDataChange

- getAnimationOnDataChange(): Promise<string>

- Gets the value of `animationOnDataChange` property. Defines the animation that is applied on data changes.

  #### Returns Promise<string>

  The value of `animationOnDataChange` property.

  Inherited from OjGanttBase.getAnimationOnDataChange

### getAnimationOnDisplay

- getAnimationOnDisplay(): Promise<string>

- Gets the value of `animationOnDisplay` property. Defines the animation that is shown on initial display.

  #### Returns Promise<string>

  The value of `animationOnDisplay` property.

  Inherited from OjGanttBase.getAnimationOnDisplay

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. An alias for the '$current' context variable passed to slot content for the dependencyTemplate, taskTemplate, or rowTemplate slots.

  ### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

  #### Returns Promise<string>

  The value of `as` property.

  Inherited from OjGanttBase.getAs

### getAttribute

- getAttribute(attributeName): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  Inherited from OjGanttBase.getAttribute

### getAxisPosition

- getAxisPosition(): Promise<string>

- Gets the value of `axisPosition` property. The position of the major and minor axis.

  #### Returns Promise<string>

  The value of `axisPosition` property.

  Inherited from OjGanttBase.getAxisPosition

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  Inherited from OjGanttBase.getCssValue

### getDependencies

- getDependencies(): Promise<Dependencies[]>

- Gets the value of `dependencies` property. An array of objects that defines dependencies between tasks. See the Help documentation for more information.

  #### Returns Promise<Dependencies[]>

  The value of `dependencies` property.

  Inherited from OjGanttBase.getDependencies

### getDependencyLineShape

- getDependencyLineShape(): Promise<string>

- Gets the value of `dependencyLineShape` property. Specifies the shape of the dependency lines.

  #### Returns Promise<string>

  The value of `dependencyLineShape` property.

  Inherited from OjGanttBase.getDependencyLineShape

### getDnd

- getDnd(): Promise<Dnd>

- Gets the value of `dnd` property. Enables drag and drop functionality.

  #### Returns Promise<Dnd>

  The value of `dnd` property.

  Inherited from OjGanttBase.getDnd

### getDragMode

- getDragMode(): Promise<string>

- Gets the value of `dragMode` property. Specifies the action that is performed when a drag occurs.

  #### Returns Promise<string>

  The value of `dragMode` property.

  Inherited from OjGanttBase.getDragMode

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from OjGanttBase.getDriver

### getEnd

- getEnd(): Promise<string>

- Gets the value of `end` property. The end time of the Gantt. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `end` property.

  Inherited from OjGanttBase.getEnd

### getGridlines

- getGridlines(): Promise<Gridlines>

- Gets the value of `gridlines` property. An object specifying whether to display or hide the horizontal and vertical grid lines.

  #### Returns Promise<Gridlines>

  The value of `gridlines` property.

  Inherited from OjGanttBase.getGridlines

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from OjGanttBase.getId

### getLocation

- getLocation(): Promise<ILocation>

- ### Inherit Doc

  #### Returns Promise<ILocation>

  Inherited from OjGanttBase.getLocation

### getMajorAxis

- getMajorAxis(): Promise<MajorAxis>

- Gets the value of `majorAxis` property. Specifies the major time axis. If not specified, no major time axis is shown.

  #### Returns Promise<MajorAxis>

  The value of `majorAxis` property.

  Inherited from OjGanttBase.getMajorAxis

### getMinorAxis

- getMinorAxis(): Promise<MinorAxis>

- Gets the value of `minorAxis` property. Specifies the minor time axis. This is required for the Gantt to render properly.

  #### Returns Promise<MinorAxis>

  The value of `minorAxis` property.

  Inherited from OjGanttBase.getMinorAxis

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjGanttBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- ### Inherit Doc

  #### Returns Promise<IRectangle>

  Inherited from OjGanttBase.getRect

### getReferenceObjects

- getReferenceObjects(): Promise<ReferenceObjects[]>

- Gets the value of `referenceObjects` property. The array of reference objects associated with the Gantt. See the Help documentation for more information.

  #### Returns Promise<ReferenceObjects[]>

  The value of `referenceObjects` property.

  Inherited from OjGanttBase.getReferenceObjects

### getRowAxis

- getRowAxis(): Promise<RowAxis>

- Gets the value of `rowAxis` property. Specifies properties for the row labels region.

  #### Returns Promise<RowAxis>

  The value of `rowAxis` property.

  Inherited from OjGanttBase.getRowAxis

### getRowDefaults

- getRowDefaults(): Promise<RowDefaults>

- Gets the value of `rowDefaults` property. Specifies default styling for rows in the Gantt.

  #### Returns Promise<RowDefaults>

  The value of `rowDefaults` property.

  Inherited from OjGanttBase.getRowDefaults

### getRows

- getRows(): Promise<Rows[]>

- Gets the value of `rows` property. An array of objects used to define rows and tasks within rows. See the Help documentation for more information.

  #### Returns Promise<Rows[]>

  The value of `rows` property.

  Inherited from OjGanttBase.getRows

### getScrollPosition

- getScrollPosition(): Promise<ScrollPosition>

- Gets the value of `scrollPosition` property. The current scroll position of the Gantt. See the Help documentation for more information.

  #### Returns Promise<ScrollPosition>

  The value of `scrollPosition` property.

  Inherited from OjGanttBase.getScrollPosition

### getSelection

- getSelection(): Promise<any[]>

- Gets the value of `selection` property. An array containing the ids of the initially selected tasks.

  #### Returns Promise<any[]>

  The value of `selection` property.

  Inherited from OjGanttBase.getSelection

### getSelectionBehavior

- getSelectionBehavior(): Promise<string>

- Gets the value of `selectionBehavior` property. Specifies the action that is performed when a drag occurs.

  #### Returns Promise<string>

  The value of `selectionBehavior` property.

  Inherited from OjGanttBase.getSelectionBehavior

### getSelectionMode

- getSelectionMode(): Promise<string>

- Gets the value of `selectionMode` property. Specifies the selection behavior of the Gantt. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `selectionMode` property.

  Inherited from OjGanttBase.getSelectionMode

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from OjGanttBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- ### Inherit Doc

  #### Returns Promise<ISize>

  Inherited from OjGanttBase.getSize

### getStart

- getStart(): Promise<string>

- Gets the value of `start` property. The start time of the Gantt. A valid value is required for the Gantt to render properly. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `start` property.

  Inherited from OjGanttBase.getStart

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from OjGanttBase.getTagName

### getTaskAggregation

- getTaskAggregation(): Promise<string>

- Gets the value of `taskAggregation` property. Specifies whether to apply a horizontally stacked visual treatment to adjacent tasks.

  #### Returns Promise<string>

  The value of `taskAggregation` property.

  Inherited from OjGanttBase.getTaskAggregation

### getTaskDefaults

- getTaskDefaults(): Promise<TaskDefaults>

- Gets the value of `taskDefaults` property. Specifies default styling for tasks in the Gantt.

  #### Returns Promise<TaskDefaults>

  The value of `taskDefaults` property.

  Inherited from OjGanttBase.getTaskDefaults

### getText

- getText(): Promise<string>

- ### Inherit Doc

  #### Returns Promise<string>

  Inherited from OjGanttBase.getText

### getTimeCursor

- getTimeCursor(): Promise<string>

- Gets the value of `timeCursor` property. Specifies whether the time cursor is enabled.

  #### Returns Promise<string>

  The value of `timeCursor` property.

  Inherited from OjGanttBase.getTimeCursor

### getTooltip

- getTooltip(): Promise<Tooltip>

- Gets the value of `tooltip` property. An object containing an optional callback function for tooltip customization.

  #### Returns Promise<Tooltip>

  The value of `tooltip` property.

  Inherited from OjGanttBase.getTooltip

### getTrackResize

- getTrackResize(): Promise<string>

- Gets the value of `trackResize` property. Defines whether the element will automatically render in response to changes in size. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `trackResize` property.

  Inherited from OjGanttBase.getTrackResize

### getTranslations

- getTranslations(): Promise<Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<Translations>

  The value of `translations` property.

  Inherited from OjGanttBase.getTranslations

### getValueFormats

- getValueFormats(): Promise<ValueFormats>

- Gets the value of `valueFormats` property. An object specifying value formatting and tooltip behavior, whose keys generally correspond to task properties.

  #### Returns Promise<ValueFormats>

  The value of `valueFormats` property.

  Inherited from OjGanttBase.getValueFormats

### getViewportEnd

- getViewportEnd(): Promise<string>

- Gets the value of `viewportEnd` property. The Gantt viewport end time. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `viewportEnd` property.

  Inherited from OjGanttBase.getViewportEnd

### getViewportStart

- getViewportStart(): Promise<string>

- Gets the value of `viewportStart` property. The Gantt viewport start time. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `viewportStart` property.

  Inherited from OjGanttBase.getViewportStart

### getZooming

- getZooming(): Promise<string>

- Gets the value of `zooming` property. Specifies whether zooming is allowed on the Gantt.

  #### Returns Promise<string>

  The value of `zooming` property.

  Inherited from OjGanttBase.getZooming

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  ### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  Inherited from OjGanttBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  ### Deprecated

  #### Returns Condition<Promise<boolean>>

  Inherited from OjGanttBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjGanttBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjGanttBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjGanttBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- ### Inherit Doc

  #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  Inherited from OjGanttBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from OjGanttBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjGanttBase.setProperty

### submit

- submit(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjGanttBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  Inherited from OjGanttBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjGanttBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjGanttBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from OjGanttBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from OjGanttBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  ### Throws

  if the object is not a valid encoded ID.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  Inherited from OjGanttBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from OjGanttBase.isId

Generated using TypeDoc